#include "SorT.h"

SorT::SorT()
{
    //ctor
    eleje=nullptr;
    vege=nullptr;
    hibas=false;
}

SorT::~SorT()
{
    //dtor
    while (!ures_e())
    {
        sorbol();
    }
}

bool SorT::ures_e()
{
    return (eleje==nullptr);
}

bool SorT::hibas_e()
{
    bool tmp=hibas;
    hibas=false;
    return tmp;
}

void SorT::sorba(ErtekT e)
{
    ElemT *uj=new ElemT;
    if (uj==nullptr)
    {
        //nem sikerult letrehozni
        hibas=true;
    }
    else
    {
        uj->ertek=e;
        uj->kov=nullptr;
        if (vege==nullptr)
        {
            eleje=uj;
        }
        else
        {
            vege->kov=uj;
        }
        vege=uj;
    }
}

ErtekT SorT::elso()
{
    if (eleje==nullptr)
    {
        hibas=true;
        return UnDef;
    }
    else
    {
        return eleje->ertek;
    }
}

ErtekT SorT::sorbol()
{
    if (eleje==nullptr)
    {
        hibas=true;
        return UnDef;
    }
    else
    {
        ErtekT e=eleje->ertek;
        ElemT *ujeleje=eleje->kov;
        delete eleje;
        eleje=ujeleje;
        if (eleje==nullptr)
        {
            vege=nullptr;
        }
        return e;
    }
}
